Index: trunk/LMDZ.VENUS/libf/phyvenus/write_histmth.h
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/write_histmth.h	(revision 888)
+++ trunk/LMDZ.VENUS/libf/phyvenus/write_histmth.h	(revision 892)
@@ -3,11 +3,4 @@
 !
       IF (ok_mensuel) THEN
-c
-      ndex2d = 0
-      ndex3d = 0
-      zx_tmp_2d = 0.
-      zx_tmp_3d = 0.
-      zx_tmp_fi2d=0.
-      zx_tmp_fi3d=0.
 
          zsto = dtime
@@ -15,244 +8,110 @@
          itau_w = itau_phy + itap
 
-c
 c-------------------------------------------------------
       IF(lev_histmth.GE.1) THEN
-c
+
 ccccccccccccc 2D fields, basics
-c
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-      CALL histwrite(nid_mth,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-      CALL histwrite(nid_mth,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ftsol,zx_tmp_2d)
-      CALL histwrite(nid_mth,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      DO i = 1, klon
-         zx_tmp_fi2d(i) = paprs(i,1)
-      ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_mth,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ue,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"ue",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ve,zx_tmp_2d)
+
+      call histwrite_phy(nid_mth,.false.,"phis",itau_w,pphis)
+      call histwrite_phy(nid_mth,.false.,"aire",itau_w,airephy)
+      call histwrite_phy(nid_mth,.false.,"tsol",itau_w,ftsol)
+      call histwrite_phy(nid_mth,.false.,"psol",itau_w,paprs(:,1))
+c     call histwrite_phy(nid_mth,.false.,"ue",itau_w,ue)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-c     zx_tmp_2d=-1.*zx_tmp_2d
-c     CALL histwrite(nid_mth,"ve",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-      CALL histwrite(nid_mth,"cdragh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-      CALL histwrite(nid_mth,"cdragm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+c     call histwrite_phy(nid_mth,.false.,"ve",itau_w,-1.*ve)
+c     call histwrite_phy(nid_mth,.false.,"cdragh",itau_w,cdragh)
+c     call histwrite_phy(nid_mth,.false.,"cdragm",itau_w,cdragm)
+
       ENDIF !lev_histmth.GE.1
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.2) THEN
-c
+
 ccccccccccccc 3D fields, basics
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_mth,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_mth,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_mth,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_mth,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
+
+      call histwrite_phy(nid_mth,.false.,"temp",itau_w,t_seri)
+      call histwrite_phy(nid_mth,.false.,"pres",itau_w,pplay)
+      call histwrite_phy(nid_mth,.false.,"geop",itau_w,zphi)
+      call histwrite_phy(nid_mth,.false.,"vitu",itau_w,u_seri)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-      zx_tmp_3d=-1.*zx_tmp_3d
-      CALL histwrite(nid_mth,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_mth,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"vitv",itau_w,-1.*v_seri)
+      call histwrite_phy(nid_mth,.false.,"vitw",itau_w,omega)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_dyn, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dudyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dudyn",itau_w,d_u_dyn)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_vdf, zx_tmp_3d)
-      CALL histwrite(nid_mth,"duvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, mang, zx_tmp_3d)
-c     CALL histwrite(nid_mth,"mang",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, ycoefh, zx_tmp_3d)
-      CALL histwrite(nid_mth,"Kz",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"duvdf",itau_w,d_u_vdf)
+c     call histwrite_phy(nid_mth,.false.,"mang",itau_w,mang)
+c     call histwrite_phy(nid_mth,.false.,"Kz",itau_w,ycoefh)
+
 c plusieurs traceurs
        IF (iflag_trac.eq.1) THEN
          DO iq=1,nqmax
-          IF (iq.LE.99) THEN
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qx(1,1,iq), zx_tmp_3d)
-       WRITE(str2,'(i2.2)') iq
-       CALL histwrite(nid_mth,tname(iq),itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-          ELSE
-       PRINT*, "Trop de traceurs"
-       CALL abort
-          ENDIF
+       call histwrite_phy(nid_mth,.false.,tname(iq),itau_w,qx(:,:,iq))
          ENDDO
        ENDIF
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"tops",itau_w,topsw)
+
       ENDIF !lev_histmth.GE.2
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.3) THEN
-c
+
 cccccccccccccccccc  Radiative transfer
-c
+
 c 2D
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_mth,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"topl",itau_w,toplw)
+      call histwrite_phy(nid_mth,.false.,"sols",itau_w,solsw)
+      call histwrite_phy(nid_mth,.false.,"soll",itau_w,sollw)
+
 c 3D
-c
-      zx_tmp_fi3d(1:klon,1:klev)=swnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"SWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=lwnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"LWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=fluxt(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"fluxvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=flux_dyn(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"fluxdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=flux_ajs(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"fluxajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     zx_tmp_fi3d(1:klon,1:klev)=flux_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_mth,"fluxec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_mth,.false.,"SWnet",itau_w,swnet)
+      call histwrite_phy(nid_mth,.false.,"LWnet",itau_w,lwnet)
+c     call histwrite_phy(nid_mth,.false.,"fluxvdf",itau_w,fluxt)
+c     call histwrite_phy(nid_mth,.false.,"fluxdyn",itau_w,flux_dyn)
+c     call histwrite_phy(nid_mth,.false.,"fluxajs",itau_w,flux_ajs)
+c     call histwrite_phy(nid_mth,.false.,"fluxec",itau_w,flux_ec)
+
       ENDIF !lev_histmth.GE.3
-c
+
 c-------------------------------------------------------
       IF(lev_histmth.GE.4) THEN
-c
+
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t_dyn, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtdyn",itau_w,d_t_dyn)
 c en K/s      
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t, zx_tmp_3d)
-c     CALL histwrite(nid_mth,"dtphy",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_mth,.false.,"dtphy",itau_w,d_t)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_vdf,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtvdf",itau_w,d_t_vdf)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_ajs,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtajs",itau_w,d_t_ajs)
 c K/day ==> K/s
-      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY 
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtswr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dtswr",itau_w,heat/RDAY)
 c K/day ==> K/s      
-      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_mth,"dtlwr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+      call histwrite_phy(nid_mth,.false.,"dtlwr",itau_w,-1.*cool/RDAY)
 c en K/s      
-c     zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_mth,"dtec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_mth,.false.,"dtec",itau_w,d_t_ec)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_ajs, zx_tmp_3d)
-      CALL histwrite(nid_mth,"duajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"duajs",itau_w,d_u_ajs)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_oro, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dugwo",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dugwo",itau_w,d_u_oro)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_hin, zx_tmp_3d)
-      CALL histwrite(nid_mth,"dugwno",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_mth,.false.,"dugwno",itau_w,d_u_hin)
 c en (m/s)/s      
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_v_vdf, zx_tmp_3d)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-c     zx_tmp_3d=-1.*zx_tmp_3d
-c     CALL histwrite(nid_mth,"dvvdf",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_mth,.false.,"dvvdf",itau_w,-1.*d_v_vdf)
+
       ENDIF !lev_histmth.GE.4
 c
 c-------------------------------------------------------
        IF(lev_histmth.GE.5) THEN
-c
-c
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxu , zx_tmp_2d)
-c      CALL histwrite(nid_mth,"taux_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d) 
-c      
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxv , zx_tmp_2d)
-c      CALL histwrite(nid_mth,"tauy_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdrm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_mth,"cdrh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+c     call histwrite_phy(nid_mth,.false.,"taux_",itau_w,fluxu)
+c     call histwrite_phy(nid_mth,.false.,"tauy_",itau_w,fluxv)
+c     call histwrite_phy(nid_mth,.false.,"cdrm",itau_w,cdragm)
+c     call histwrite_phy(nid_mth,.false.,"cdrh",itau_w,cdragh)
+
       ENDIF !lev_histmth.GE.5
 c-------------------------------------------------------
@@ -261,3 +120,4 @@
         call histsync(nid_mth)
       endif
+
       ENDIF
Index: trunk/LMDZ.VENUS/libf/phyvenus/zenang.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/zenang.F	(revision 888)
+++ trunk/LMDZ.VENUS/libf/phyvenus/zenang.F	(revision 892)
@@ -34,5 +34,5 @@
       integer i
       real gmtime1, gmtime2
-      real pi_local, deux_pi_local, incl
+      real incl
       real omega1, omega2, omega
 c omega1, omega2 : temps 1 et 2 exprime en radian avec 0 a midi.
@@ -46,9 +46,7 @@
 c================================================================
 c
-      pi_local = 4.0 * ATAN(1.0)
-      deux_pi_local = 2.0 * pi_local
-      incl=R_incl * pi_local / 180.
+      incl=R_incl * RPI / 180.
 c
-      lon_sun = longi * pi_local / 180.0
+      lon_sun = longi * RPI / 180.0
       lat_sun = ASIN (SIN(lon_sun)*SIN(incl) )
 c
@@ -58,5 +56,5 @@
       DO i = 1, klon
 c
-      latr = lat(i) * pi_local / 180.
+      latr = lat(i) * RPI / 180.
 c
 c--pose probleme quand lat=+/-90 degres
@@ -64,11 +62,11 @@
 c      omega = -TAN(latr)*TAN(lat_sun)
 c      omega = ACOS(omega)
-c      IF (latr.GE.(pi_local/2.+lat_sun)
-c     .    .OR. latr.LE.(-pi_local/2.+lat_sun)) THEN
+c      IF (latr.GE.(RPI/2.+lat_sun)
+c     .    .OR. latr.LE.(-RPI/2.+lat_sun)) THEN
 c         omega = 0.0       ! nuit polaire
 c      ENDIF
-c      IF (latr.GE.(pi_local/2.-lat_sun)
-c     .          .OR. latr.LE.(-pi_local/2.-lat_sun)) THEN
-c         omega = pi_local  ! journee polaire
+c      IF (latr.GE.(RPI/2.-lat_sun)
+c     .          .OR. latr.LE.(-RPI/2.-lat_sun)) THEN
+c         omega = RPI  ! journee polaire
 c      ENDIF
 c
@@ -76,12 +74,12 @@
 c
       omega=0.0  !--nuit polaire
-      IF (latr.GE.(pi_local/2.-lat_sun)
-     .          .OR. latr.LE.(-pi_local/2.-lat_sun)) THEN
-         omega = pi_local  ! journee polaire
+      IF (latr.GE.(RPI/2.-lat_sun)
+     .          .OR. latr.LE.(-RPI/2.-lat_sun)) THEN
+         omega = RPI  ! journee polaire
       ENDIF
-      IF (latr.LT.(pi_local/2.+lat_sun).AND.
-     .    latr.GT.(-pi_local/2.+lat_sun).AND.
-     .    latr.LT.(pi_local/2.-lat_sun).AND.
-     .    latr.GT.(-pi_local/2.-lat_sun)) THEN
+      IF (latr.LT.(RPI/2.+lat_sun).AND.
+     .    latr.GT.(-RPI/2.+lat_sun).AND.
+     .    latr.LT.(RPI/2.-lat_sun).AND.
+     .    latr.GT.(-RPI/2.-lat_sun)) THEN
       omega = -TAN(latr)*TAN(lat_sun)
       omega = ACOS(omega)
@@ -89,12 +87,12 @@
 c
          omega1 = gmtime1 + long(i)*RDAY/360.0
-         omega1 = omega1 / RDAY*deux_pi_local
-         omega1 = MOD (omega1+deux_pi_local, deux_pi_local)
-         omega1 = omega1 - pi_local
+         omega1 = omega1*2*RPI / RDAY
+         omega1 = MOD (omega1+2*RPI, 2*RPI)
+         omega1 = omega1 - RPI
 c
          omega2 = gmtime2 + long(i)*RDAY/360.0
-         omega2 = omega2 / RDAY*deux_pi_local
-         omega2 = MOD (omega2+deux_pi_local, deux_pi_local)
-         omega2 = omega2 - pi_local
+         omega2 = omega2*2*RPI / RDAY
+         omega2 = MOD (omega2+2*RPI, 2*RPI)
+         omega2 = omega2 - RPI
 c
       IF (omega1.LE.omega2) THEN  !--on est dans la meme journee locale
@@ -144,5 +142,5 @@
       ENDIF
 c-----------------------moyenne 
-      frac(i)=(zfrac1+zfrac2)/(omega2+deux_pi_local-omega1)
+      frac(i)=(zfrac1+zfrac2)/(omega2+2*RPI-omega1)
       pmu0(i)=(zfrac1*z1_mu+zfrac2*z2_mu)/MAX(zfrac1+zfrac2,1.E-10)
 c
